<?php


include_once "oai2/MetadataRecord.php";
include_once "oai2/DublinCore.php";



class DcMetadataRecord extends MetadataRecord {


    function DcMetadataRecord($identifier, $datestamp, $deleted, $sets) {
	$this->MetadataRecord($identifier, $datestamp, $deleted, $sets);
	$this->fields = array();
    }


    function addEntryAsUtf8($field, $content) {
	$this->addEntry($field, stringToUtf8($content));
    }


    // Add an entry to this record. This method facilitates
    // incremental construction of the record.
    function addEntry($field, $content) {
	global $DcFields;
	global $xmlescaped;

	if (array_search($field, $DcFields) === NULL) {
	    error("DcMetadataRecord::addEntry: unknown DC field " . $field);
	}

	if ($xmlescaped == false) {
	    $content = htmlspecialchars($content, ENT_NOQUOTES);
	}
	if (array_key_exists($field, $this->fields)) {
	    array_push($this->fields[$field], $content);
	} else {
	    $this->fields[$field] = array($content);
	}
    }


    // This method creates a XML string that represents the record.
    function metadataToXmlString($indent) {
	global $DcFields;

	$result = str_pad("", $indent) . "<metadata>\n";
	$indent += 4;
	$result .= str_pad("", $indent) . "<oai_dc:dc\n";
	$result .= str_pad("", $indent + 2) . "xmlns:oai_dc=\"http://www.openarchives.org/OAI/2.0/oai_dc/\"\n";
	$result .= str_pad("", $indent + 2) . "xmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n" ;
	$result .= str_pad("", $indent + 2) . "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n";
	$result .= str_pad("", $indent + 2) . "xsi:schemaLocation=\"http://www.openarchives.org/OAI/2.0/oai_dc/\n";
	$result .= str_pad("", $indent + 22) . "http://www.openarchives.org/OAI/2.0/oai_dc.xsd\">\n";
	$indent += 4;
	foreach ($DcFields as $field) {
	    $contentArray = $this->fields[$field];
	    if ($contentArray) {
		foreach ($contentArray as $content) {
		    $result .= str_pad("", $indent) . "<dc:" . $field . ">" . $content . "</dc:" . $field . ">\n";
		}
	    }
	}
	$indent -= 4;
	$result .= str_pad("", $indent) . "</oai_dc:dc>\n";
	$indent -= 4;
	$result .= str_pad("", $indent) . "</metadata>\n";
	return $result;
    }
}


?>
