<?php


require_once('DB.php');
include_once "oai2/Provider.php";
include_once "oai2/Mek2DcMetadataReader.php";
include_once "oai2/latin2_utf8.php";



class Mek2OaiDcHandlerFactory extends HandlerFactory {

    function Mek2OaiDcHandlerFactory($dataSource) {
	$this->dataSource = $dataSource;
    }

    function createHandler($invokingProvider) {
	return new Mek2DcMetadataReader($this->dataSource);
    }

    function resumeFrom($invokingProvider, $fileName) {
	return Mek2DcRecordIterator::readFrom($fileName);
    }
}



class Mek2Provider extends Provider {


    function getFormats($identifier) {

	/*
	 * Get the format for this identifier.
	 * TODO: check for existence of the identifier.
	 */
	return array("oai_dc");
    }


    function getRows($table, $field, $value) {

	if (is_string($value)) {
	    $query = "select * from $table where $field = \"$value\"";
	} else {
	    $query = "select * from $table where $field = $value";
	}

	$recordResult = $this->dataBase->query($query);
	if (DB::isError($recordResult)) {
	    die($recordResult->getMessage());
	}

	$numberOfRows = $recordResult->numRows();
	if (DB::isError($numberOfRows)) {
	    die($numberOfRows->getMessage());
	}

	$theResult = array();
	for ($count = 0; $count < $numberOfRows; $count++) {
	    $aRow = $recordResult->fetchRow();
	    if (DB::isError($aRow)) {
		die($aRow->getMessage());
	    }
	    array_push($theResult, $aRow);
	}
	return $theResult;
    }



    function RecordExists($anIdentifier) {
	return $this->getRows("dc_identifier", "mekid", $anIdentifier);
    }


    function Mek2Provider($dataSource, $anUrl, $providerId) {
	$this->Provider($anUrl, $providerId);
	$this->dataSource = $dataSource;
	$this->registerMetadataFormat
	    ("oai_dc",
	     new Mek2OaiDcHandlerFactory($dataSource),
	     "http://www.openarchives.org/OAI/2.0/oai_dc.xsd",
	     "http://www.openarchives.org/OAI/2.0/oai_dc/");

	/*
	 * This is an example for registration of additional metadata
	 * handlers
	 */
	//$this->registerMetadataFormat
	//    ("mek2",
	//     new Mek2OaiMek2HandlerFactory($dataSource),
	//     "http://mek.oszk.hu/OAI/2.0/mek2.xsd",
	//     "http://mek.oszk.hu/OAI/2.0/mek2/");

	$this->dataBase = DB::connect($dataSource);
	if (DB::isError($this->dataBase)) {
	    die($this->dataBase->getMessage());
	}
	$this->dataBase->setFetchMode(DB_FETCHMODE_ASSOC);

	/*
	 * Add the sets to this instance of Provider.
	 */
	$theSets = array();
	$theRows = $this->getRows("subtopic", "1", 1);
	foreach ($theRows as $value) {

	    // Get the set names
	    if (!$value["gyujto"] || !$value["topic"] || !$value["subtopicid"]) {
		continue;
	    }
	    $broadName = $theSets[$value["gyujto"]];
	    if (!$broadName) {
		$theNames = $this->getRows("broadtopic", "gyujto", $value["gyujto"]);
		if (count($theNames) != 1) {
		    die("No or multiple broadtopic names");
		}
		$broadName = $theNames[0]["lista"];
		$theSets[$value["gyujto"]] = $broadName;
		$this->addSet($value["gyujto"], $broadName);
	    }

	    // Get the set names
	    $topicName = $theSets[$value["gyujto"] . ":" . $value["topic"]];
	    if (!$topicName) {
		$theNames = $this->getRows("topic_l2", "topic", $value["topic"]);
		if (count($theNames) != 1) {
		    die("Missing or multiple topic names");
		    //$topicName = $value["topic"];
		} else {
		    $topicName = $theNames[0]["lista"];
		}
		$theSets[$value["gyujto"] . ":" . $value["topic"]] = $topicName;
		$this->addSet($value["gyujto"] . ":" . $value["topic"], $topicName);
	    }

	    // Get the set names
	    $subtopicName = $theSets[$value["gyujto"] . ":" . $value["topic"] . ":" . $value["subtopicid"]];
	    if (!$subtopicName) {
		$theNames = $this->getRows("subtopic", "subtopicid", $value["subtopicid"]);
		if (count($theNames) != 1) {
		    die("No or multiple subtopic names");
		}
		$subtopicName = $theNames[0]["lista"];
		$theSets[$value["gyujto"] . ":" . $value["topic"] . ":" . $value["subtopicid"]] = $subtopicName;
		$this->addSet($value["gyujto"] . ":" . $value["topic"] . ":" . $value["subtopicid"], $subtopicName);
	    }
	}
    }
}


?>
