<?php


class MetadataRecord {


    function output($indent) {
        print $this->toXmlString($indent);
    }


    function outputToStream($streamHandler, $indent) {
	$aXmlString = fwrite($streamHandle, $this->toXmlString($indent));
    }


    // This function converts the record to an OAI compliant XML
    // string.
    // Implement this function in derived classes
    function metadataToXmlString($indent) {
	error("MetadataRecord::metadataToXmlString: Subclass responsibility");
    }


    function MetadataRecord($identifier, $datestamp, $deleted, $sets = NULL) {
	$this->identifier = $identifier;
	$this->datestamp  = $datestamp;
	$this->deleted    = $deleted;
	if ($sets) {
	    $this->sets = $sets;
	} else {
	    $this->sets = array();
	}
    }


    function getIdentifier() {
	return $this->identifier;
    }

    function getDatestamp() {
	return $this->datestamp;
    }

    function getDeleted() {
	return $this->deleted;
    }


    function addSet($set) {
	array_push($this->sets, $set);
    }


    function getSets() {
	return $this->sets;
    }


    function headerToXmlString($indent) {
	$datestring = $this->datestamp;
	if (strlen($datestring) > 10) {
	    $datestring[10]  = "T";
	    if (strlen($datestring) < 20) {
		$datestring .= "Z";
	    }
	} else {
	    $datestring .= "T00:00:00Z";
	}

	if ($this->deleted) {
	    $result = str_pad("", $indent) . "<header status=\"deleted\">\n";
	} else {
	    $result = str_pad("", $indent) . "<header>\n";
	}
	$indent += 4;
	$result .= str_pad("", $indent) . "<identifier>" . $this->identifier . "</identifier>\n";
	$result .= str_pad("", $indent) . "<datestamp>" . $datestring . "</datestamp>\n";
	if (!$this->deleted) {
	    foreach($this->sets as $set) {
		$result .= str_pad("", $indent) . "<setSpec>$set</setSpec>\n";
	    }
	}
	$indent -= 4;
	$result .= str_pad("", $indent) . "</header>\n";
	return $result;
    }
}



?>
