<?php


class RecordIterator {

    // Return the number of elements
    function elements() {
	die("RecordIterator::elements: Subclass responsibility");
    }

    function hasMoreElements() {
	die("RecordIterator::hasMoreElements: Subclass responsibility");
    }

    function &getNextElement() {
	die("RecordIterator::getNextElement: Subclass responsibility");
    }

    function storeTo($fileName) {
	die("RecordIterator::storeTo: Subclass responsibility");	
    }

    // static method
    function readFrom($fileName) {
	die("RecordIterator::readFrom: Subclass responsibility");	
    }
}



class MetadataRecordReader {


    /*
     * This method queries the database to get all records
     * that comply to the given restrictions. The providerUrl allows to restrict
     * the retrieval to all records from a given URL.
     *
     * It returns a subclass of RecordIterator.
     */
    function getRecords($providerUrl, $from, $until, $set, $format = "oai_dc") {
	die("MetadataRecordReader::getRecord: Subclass responsibility");
    }

    /*
     * This method queries the database to the record with the unique
     * identifier $identifier.  The providerUrl allows to restrict the
     * retrieval to all records from a given URL.
     *
     * It returns a subclass of MetadataRecord.
     */
    function getRecord($providerUrl, $identifier, $format = "oai_dc") {
	die("MetadataRecordReader::readRecord: Subclass responsibility");
    }
}


?>
