<?
/*
* +----------------------------------------------------------------------+
* | PHP Version 4                                                        |
* +----------------------------------------------------------------------+
* | Copyright (c) 2002 Heinrich Stamerjohanns                            |
* |                                                                      |
* | listidentifiers.php -- Utilities for the OAI Data Provider           |
* |                                                                      |
* | This is free software; you can redistribute it and/or modify it under|
* | the terms of the GNU General Public License as published by the      |
* | Free Software Foundation; either version 2 of the License, or (at    |
* | your option) any later version.                                      |
* | This software is distributed in the hope that it will be useful, but |
* | WITHOUT  ANY WARRANTY; without even the implied warranty of          |
* | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the         |
* | GNU General Public License for more details.                         |
* | You should have received a copy of the GNU General Public License    |
* | along with  software; if not, write to the Free Software Foundation, |
* | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA         |
* |                                                                      |
* +----------------------------------------------------------------------+
* | Derived from work by U. Mller, HUB Berlin                           |
* |                                                                      |
* | Written by Heinrich Stamerjohanns, May 2002                          |
* |            stamer@uni-oldenburg.de                                   |
* +----------------------------------------------------------------------+
*/
//
// $Id: listidentifiers.php,v 1.02 2003/04/08 14:17:47 stamer Exp $
//

// parse and check arguments
foreach($args as $key => $val) {

    $KEYS .= "$key<BR>\n";

    switch ($key) { 
    case 'until':
	if (!isset($until))
	    $until = $val; 
	else 
	    $errors .= oai_error('badArgument', $key, $val);
	break;

    case 'from':
	if (!isset($from))
	    $from = $val;
	else 
	    $errors .= oai_error('badArgument', $key, $val);
	break;
	
    case 'set':
	if (!isset($set))
	    $set = $val;
	else 
	    $errors .= oai_error('badArgument', $key, $val);
	break;      
	
    case 'metadataPrefix':
	if (!isset($metadataPrefix))
	    $metadataPrefix = $val;
	else 
	    $errors .= oai_error('badArgument', $key, $val);
	break;

    case 'resumptionToken':
	if (!isset($resumptionToken)) 
	    $resumptionToken = $val;
	else 
	    $errors .= oai_error('badArgument', $key, $val);
	break;
	
    default:
	$errors .= oai_error('badArgument', $key, $val);
    }
}

// Resume previous session?
if (isset($args['resumptionToken'])) {            
    if (isset($args['metadataPrefix']) || isset($args['from'])
	|| isset($args['until']) || isset($args['set'])) {
	$errors .= oai_error('exclusiveArgument');
    } else {
	if (is_file("tokens/prefix-$resumptionToken") && is_file("tokens/token-$resumptionToken")) {
	    $metadataPrefix = ReadPrefixFrom("tokens/prefix-$resumptionToken");
	    $recordIterator = $TheProvider->resumeForMetadataFormatFrom($metadataPrefix, "tokens/token-$resumptionToken");
	    unlink ("tokens/prefix-$resumptionToken");
	    unlink ("tokens/token-$resumptionToken");
	} else {
	    $errors .= oai_error('badResumptionToken', '', $resumptionToken);
	}
    }
}
// no, new session
else {

    if (!isset($args['metadataPrefix'])) {
	$errors .= oai_error('missingArgument', 'metadataPrefix');
    }

    // CM
    $TheRecordReader = $TheProvider->getHandlerForMetadataFormat($metadataPrefix);
    if ($TheRecordReader == NULL) {
	$errors .= oai_error('cannotDisseminateFormat', "metadataPrefix", $metadataPrefix);
    }

    if (isset($args['from'])) {
	if (!checkDateFormat($from)) {
	    $errors .= oai_error('badGranularity', 'from', $from);
	}
    }

    if (isset($args['until'])) {
	if (!checkDateFormat($until)) {
	    $errors .= oai_error('badGranularity', 'until', $until); 
	}
    }

    if (!isset($errors)) {
	$recordIterator = $TheRecordReader->getRecords($TheProviderUrl, $from, $until, $args['set']);
	$num_rows = $recordIterator->elements();  
	if (!$num_rows) {
	    $errors .= oai_error('noRecordsMatch');
	}
    }
}

// break and clean up on error
if (isset($errors)) {
	oai_exit();
}

$output .= " <ListIdentifiers>\n";


$maxrec = min($recordIterator->elements(), $MAXIDS);
$countrec = 0;
while ($countrec++ < $maxrec) {

    $aRecord = $recordIterator->getNextElement();
    $deleted = $aRecord->getDeleted();

    if ($deleted && ($deletedRecord == 'transient' || $deletedRecord == 'persistent')) {
	$status_deleted = true;
    } else {
	$status_deleted = false;
    }

    $output .= $aRecord->headerToXmlString(4);
}


// Do we need a ResumptionToken?
if ($recordIterator->elements() > 0) {
    $token = get_token();
    $recordIterator->writeTo("tokens/token-$token");    
    WritePrefixTo("tokens/prefix-$token", $metadataPrefix);
    $output .=
'  <resumptionToken expirationDate="'.$expirationdatetime.'"
     completeListSize="'.$recordIterator->totalElements().'"
     cursor="'.$recordIterator->readElements().'">'.$token."</resumptionToken>\n";
} elseif (isset($set_resumptionToken)) {
    $output .=
'  <resumptionToken completeListSize="'.$recordIterator->totalElements().'"
     cursor="'.$recordIterator->readElements().'"></resumptionToken>'."\n";
}

$output .= " </ListIdentifiers>\n"; 

?>
